/*
===============================================================================
 Name        : main.c
 Author      : $(author)
 Version     :
 Copyright   : $(copyright)
 Description : main definition
===============================================================================
*/

#if defined (__USE_LPCOPEN)
#if defined(NO_BOARD_LIB)
#include "chip.h"
#else
#include "board.h"
#endif
#endif

#include <cr_section_macros.h>

// TODO: insert other include files here
#include "i2cm.h"
#include "aqm0802a.h"
#include "form.h"
#include "mrt.h"

// TODO: insert other definitions and declarations here
#define ADC_ADRS (0x25 << 1)

void alarm(uint8_t adrs, ErrorCode_t err){
	Chip_GPIO_SetPinOutHigh(LPC_GPIO_PORT, 0, 2);
	while(1);
}

int main(void) {

#if defined (__USE_LPCOPEN)
#if !defined(NO_BOARD_LIB)
    // Read clock settings and update SystemCoreClock variable
    SystemCoreClockUpdate();
    // Set up and initialize all required blocks and
    // functions related to the board hardware
    Board_Init();
    // Set the LED to the state of "On"
    Board_LED_Set(0, true);
#endif
#endif

    // TODO: insert code here
	SystemCoreClockUpdate();

	//Pin assign
	Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_SWM);
	Chip_SWM_DisableFixedPin(SWM_FIXED_SWCLK);// Disable SWCLK
	Chip_SWM_DisableFixedPin(SWM_FIXED_SWDIO);// Disable SWDIO
 	Chip_SWM_MovablePinAssign(SWM_I2C_SDA_IO, 0);// I2C_SDA
	Chip_SWM_MovablePinAssign(SWM_I2C_SCL_IO, 1);// I2C_SCL
 	Chip_Clock_DisablePeriphClock(SYSCTL_CLOCK_SWM);

	//GPIO setup
	//Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_GPIO);
	Chip_GPIO_SetPinDIROutput(LPC_GPIO_PORT, 0, 2);
	Chip_GPIO_SetPinDIROutput(LPC_GPIO_PORT, 0, 3);
	Chip_GPIO_SetPinOutLow(LPC_GPIO_PORT, 0, 2);
	Chip_GPIO_SetPinOutLow(LPC_GPIO_PORT, 0, 3);

	mrtSetup();
	i2cmSetupErr(alarm);
	i2cmSetup();
	lcdSetup();

	lcdLocate(0, 0);
	lcdPuts("Voltage ");
	lcdLocate(0, 1);
	lcdPuts("Wait....");

	mrtWait(MRT_MS(1000));
	lcdLocate(5, 1);
	lcdPuts("V  ");

	uint8_t i2cbuf[3];
	i2cbuf[0] = ADC_ADRS;
	int16_t volt;
	while(1){
		i2cmRx(i2cbuf, 3);
		volt = (i2cbuf[1] << 8) | i2cbuf[2];

		lcdLocate(0, 1);
		lcdPuts(formDec(volt, 1, 3));
		mrtWait(MRT_MS(1000));
	}
    return 0 ;
}
