/*
 * am2321.c
 *
 *  Created on: 2014/11/24
 *      Author: Tetsuya Suzuki
 */

#include "chip.h"
#include "mrt.h"
#include "i2cm.h"
#include "am2321.h"

int aosMeasure(int *hum, int *tmp) {
	uint8_t buf[9];
	uint16_t crc;

	buf[0] = AOS_ADRS;
	i2cmTx(buf, 1);
	mrtWait(MRT_MS(1));

	buf[1] = 0x03;
	buf[2] = 0x00;
	buf[3] = 0x04;
	i2cmTx(buf, 4);
	mrtWait(MRT_US(1500));

	i2cmRx(buf, 9);

	uint16_t chk = 0xffff;
	int i, j;
	for (i = 1; i <= 6; i++) {
		chk ^= buf[i];
		for (j = 0; j < 8; j++)
			if (chk & 0x01) {
				chk >>= 1;
				chk ^= 0xa001;
			} else
				chk >>= 1;
	}

	crc = ((uint16_t) buf[8] << 8) | buf[7];
	if (crc != chk)
		return -1;

	*hum = ((uint32_t) buf[3] << 8) | buf[4];
	*tmp = ((uint32_t) (buf[5] & 0x7f) << 8) | buf[6];
	*tmp *= (buf[5] & 0x80) ? -1: 1;
	return 0;
}
