/*
 ===============================================================================
 Name        : main.c
 Author      : $(author)
 Version     :
 Copyright   : $(copyright)
 Description : main definition
 ===============================================================================
 */

#if defined (__USE_LPCOPEN)
#if defined(NO_BOARD_LIB)
#include "chip.h"
#else
#include "board.h"
#endif
#endif

#include <cr_section_macros.h>

// TODO: insert other include files here
#include "uart.h"
#include "form.h"
#include "mrt.h"
#include "i2cm.h"
#include "lps25h.h"

// TODO: insert other definitions and declarations here
int main(void) {

#if defined (__USE_LPCOPEN)
#if !defined(NO_BOARD_LIB)
	// Read clock settings and update SystemCoreClock variable
	SystemCoreClockUpdate();
	// Set up and initialize all required blocks and
	// functions related to the board hardware
	Board_Init();
	// Set the LED to the state of "On"
	Board_LED_Set(0, true);
#endif
#endif

	// TODO: insert code here
	SystemCoreClockUpdate();

	Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_SWM);
	Chip_SWM_DisableFixedPin(SWM_FIXED_SWCLK);
	Chip_SWM_DisableFixedPin(SWM_FIXED_SWDIO);
	Chip_SWM_MovablePinAssign(SWM_I2C_SDA_IO, 2);
	Chip_SWM_MovablePinAssign(SWM_I2C_SCL_IO, 3);
	Chip_SWM_MovablePinAssign(SWM_U0_TXD_O, 4);
	Chip_SWM_MovablePinAssign(SWM_U0_RXD_I, 0);
	Chip_Clock_DisablePeriphClock(SYSCTL_CLOCK_SWM);

	uartSetup();
	i2cmSetup();
	mrtSetup();
	lpsSetup();

	uartPuts("Barometer\r\n");
	while (1) {
		float atm;
		float tmp;

		lpsMeasure(&atm, &tmp);
		uartPuts("ATM:");
		uartPuts(formFloat(atm, 4, 2));
		uartPuts("hPa, TMP:");
		uartPuts(formFloat(tmp, 2, 2));
		uartPuts("*C\r\n");
		mrtWait(MRT_MS(2000));
	}
	return 0;
}
