/*
 * i2cs.h
 *
 *  Created on: 2014/10/15
 *      Author: Tetsuya
 */

#ifndef FRQ810_ROM_SRC_ROMI2CS_H_
#define FRQ810_ROM_SRC_ROMI2CS_H_
#ifdef __cplusplus
extern "C" {
#endif

//受信データが保存されるバッファ(先頭はアドレス)
extern uint8_t i2csRxBuf[];

//送信データを保存するバッファ
extern uint8_t i2csTxBuf[];

//エラー発生時に呼び出す関数を登録する
//引数は関数名
void i2csSetupErr(void (*pFunc)(void));

//受信完了時に呼び出す関数を登録する
//引数は関数名
void i2csSetupRx(void (*pFunc)(void));

//送信完了時に呼び出す関数を登録する
//引数は関数名
void i2csSetupTx(void (*pFunc)(void));

//I2Cをセットアップする
//引数addr:スレーブアドレス
//引数rxn:受信バイト数(アドレスを含む)
//引数txn:送信バイト数
void i2csSetup(uint32_t addr, uint32_t rxn, uint32_t txn);

#ifdef __cplusplus
}
#endif
#endif /* FRQ810_ROM_SRC_ROMI2CS_H_ */
