/*
===============================================================================
 Name        : main.c
 Author      : $(author)
 Version     :
 Copyright   : $(copyright)
 Description : main definition
===============================================================================
*/

#if defined (__USE_LPCOPEN)
#if defined(NO_BOARD_LIB)
#include "chip.h"
#else
#include "board.h"
#endif
#endif

#include <cr_section_macros.h>

// TODO: insert other include files here

// TODO: insert other definitions and declarations here
uint8_t num[3];
uint8_t dot;

SPI_DATA_SETUP_T sup;
uint16_t sig;

void update(){
	static uint8_t seg;
	static const uint8_t sel[] = {
			0b01100000, 0b10100000, 0b11000000
	};

	sig = sel[seg] | ((seg == dot) << 4) | (num[seg] & 0xf);
	Chip_SPI_WriteFrames_Blocking(LPC_SPI0, &sup);
	seg++;
	if(seg >= 3)
		seg = 0;
}

void countdown(){
	static uint8_t time = 180;

	num[2] = time / 60;
	num[1] = (time % 60) / 10;
	num[0] = (time % 60) % 10;
	if(time <= 0){
		Chip_MRT_SetDisabled(LPC_MRT_CH(1));
	} else {
		time--;
	}
}

void MRT_IRQHandler(void){
	uint32_t intf;

	/* Get interrupt pending status for all timers */
	intf = Chip_MRT_GetIntPending();
	Chip_MRT_ClearIntPending(intf);

	// Call repeat function
	if(intf & MRT0_INTFLAG)
		update();

	if(intf & MRT1_INTFLAG)
		countdown();
}

int main(void) {

#if defined (__USE_LPCOPEN)
#if !defined(NO_BOARD_LIB)
    // Read clock settings and update SystemCoreClock variable
    SystemCoreClockUpdate();
    // Set up and initialize all required blocks and
    // functions related to the board hardware
    Board_Init();
    // Set the LED to the state of "On"
    Board_LED_Set(0, true);
#endif
#endif

    // TODO: insert code here
    SystemCoreClockUpdate();

	//Pin assign
	Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_SWM);
	Chip_SWM_DisableFixedPin(SWM_FIXED_SWCLK);// Disable SWCLK
	Chip_SWM_DisableFixedPin(SWM_FIXED_SWDIO);// Disable SWDIO
	Chip_SWM_MovablePinAssign(SWM_SPI0_SCK_IO, 2);
	Chip_SWM_MovablePinAssign(SWM_SPI0_MOSI_IO, 4);
	Chip_SWM_MovablePinAssign(SWM_SPI0_SSEL_IO, 3);
 	Chip_Clock_DisablePeriphClock(SYSCTL_CLOCK_SWM);

	Chip_SPI_Init(LPC_SPI0);
	Chip_SPI_ConfigureSPI(LPC_SPI0, SPI_MODE_MASTER);
	Chip_SPI_Enable(LPC_SPI0);

	sup.Length = 1;
	sup.pTx = &sig;
	sup.TxCnt = 0;
	sup.DataSize = 8;

	num[2] = 3;
	num[1] = 0;
	num[0] = 0;
	dot = 2;

	//MRT setup
	Chip_MRT_Init();
	Chip_MRT_SetMode(LPC_MRT_CH(0), MRT_MODE_REPEAT);/* Timer mode */
	Chip_MRT_SetInterval(LPC_MRT_CH(0), (SystemCoreClock / (60 * 3)) | MRT_INTVAL_LOAD);
	Chip_MRT_SetEnabled(LPC_MRT_CH(0));
	Chip_MRT_SetMode(LPC_MRT_CH(1), MRT_MODE_REPEAT);/* Timer mode */
	Chip_MRT_SetInterval(LPC_MRT_CH(1), SystemCoreClock | MRT_INTVAL_LOAD);
	Chip_MRT_SetEnabled(LPC_MRT_CH(1));
	NVIC_EnableIRQ(MRT_IRQn);/* Enable the interrupt for the MRT */

	while(1) __WFI();
    return 0 ;
}
