/*
 * lps25h.c
 *
 *  Created on: 2014/11/24
 *      Author: Tetsuya Suzuki
 */

#include "chip.h"
#include "i2cm.h"
#include "lps25h.h"

void lpsWrite(uint8_t reg, uint8_t data) {
	uint8_t buf[3];

	buf[0] = LPS_ADRS;
	buf[1] = reg;
	buf[2] = data;
	i2cmTx(buf, 3);
}

uint8_t lpsRead(uint8_t reg) {
	uint8_t buf[2];

	buf[0] = LPS_ADRS;
	buf[1] = reg;
	i2cmTx(buf, 2);
	i2cmRx(buf, 2);
	return buf[1];
}

void lpsSetup() {lpsWrite(0x20, 0x80);}

void lpsMeasure(float *atm, float *tmp) {
	union {
		uint8_t b[6];
		int32_t p[1];
		int16_t t[3];
	} buf;

	lpsWrite(0x21, 1);
	while ((lpsRead(0x27) & 3) != 3);

	buf.b[0] = LPS_ADRS;
	buf.b[1] = (0x28 | 0x80);
	i2cmTx(buf.b, 2);
	i2cmRx(buf.b, 6);

	*atm = (float) (buf.p[0] / 256) / 4096;
	*tmp = 42.5 + (float) buf.t[2] / 480;
}
