/*
===============================================================================
 Name        : main.c
 Author      : $(author)
 Version     :
 Copyright   : $(copyright)
 Description : main definition
===============================================================================
*/

#if defined (__USE_LPCOPEN)
#if defined(NO_BOARD_LIB)
#include "chip.h"
#else
#include "board.h"
#endif
#endif

#include <cr_section_macros.h>

// TODO: insert other include files here
// TODO: insert other definitions and declarations here
void WKT_IRQHandler(void){
	Chip_WKT_ClearIntStatus(LPC_WKT);
	SCB->SCR = 0;
	LPC_PMU->PCON = PMU_PCON_PM_SLEEP;
}

int main(void) {

#if defined (__USE_LPCOPEN)
#if !defined(NO_BOARD_LIB)
    // Read clock settings and update SystemCoreClock variable
    SystemCoreClockUpdate();
    // Set up and initialize all required blocks and
    // functions related to the board hardware
    Board_Init();
    // Set the LED to the state of "On"
    Board_LED_Set(0, true);
#endif
#endif

    // TODO: insert code here
    SystemCoreClockUpdate();

	Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_SWM);
	Chip_SWM_DisableFixedPin(SWM_FIXED_SWDIO);
	Chip_Clock_DisablePeriphClock(SYSCTL_CLOCK_SWM);

	Chip_GPIO_SetPinDIROutput(LPC_GPIO_PORT, 0, 2);
	Chip_GPIO_SetPinOutLow(LPC_GPIO_PORT, 0, 2);
	Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_WKT);
	Chip_SYSCTL_PeriphReset(RESET_WKT);
	Chip_SYSCTL_EnablePeriphWakeup(SYSCTL_WAKEUP_WKTINT);
	Chip_WKT_SetClockSource(LPC_WKT, WKT_CLKSRC_10KHZ);
	NVIC_EnableIRQ(WKT_IRQn);

	Chip_PMU_SetPowerDownControl(LPC_PMU,
		PMU_DPDCTRL_WAKEPAD |
		PMU_DPDCTRL_LPOSCEN |
		PMU_DPDCTRL_LPOSCDPDEN
	);

	Chip_SYSCTL_SetDeepSleepPD(
		SYSCTL_DEEPSLP_BOD_PD |
		SYSCTL_DEEPSLP_WDTOSC_PD
	);

	Chip_SYSCTL_SetWakeup(~(
		SYSCTL_SLPWAKE_IRC_PD |
		SYSCTL_SLPWAKE_IRCOUT_PD |
		SYSCTL_SLPWAKE_SYSPLL_PD |
		SYSCTL_SLPWAKE_FLASH_PD
	));

	while (1) {
		Chip_GPIO_SetPinOutHigh(LPC_GPIO_PORT, 0, 2);
		Chip_WKT_LoadCount(LPC_WKT, 5000);
		Chip_PMU_Sleep(LPC_PMU, PMU_MCU_POWER_DOWN);
		Chip_GPIO_SetPinOutLow(LPC_GPIO_PORT, 0, 2);
		Chip_WKT_LoadCount(LPC_WKT, 50000);
		//Chip_PMU_Sleep(LPC_PMU, PMU_MCU_SLEEP);
		//Chip_PMU_Sleep(LPC_PMU, PMU_MCU_DEEP_SLEEP);
		Chip_PMU_Sleep(LPC_PMU, PMU_MCU_POWER_DOWN);
		//Chip_PMU_Sleep(LPC_PMU, PMU_MCU_DEEP_PWRDOWN);
	}
    return 0 ;
}
