/*
===============================================================================
 Name        : osc810.c
 Author      : $(author)
 Version     :
 Copyright   : $(copyright)
 Description : main definition
===============================================================================
*/

#if defined (__USE_LPCOPEN)
#if defined(NO_BOARD_LIB)
#include "chip.h"
#else
#include "board.h"
#endif
#endif

#include <cr_section_macros.h>

// TODO: insert other include files here
#include "mrt.h"

// TODO: insert other definitions and declarations here
void changeFreq(){
	uint32_t sw;
	uint32_t hz;

	sw = Chip_GPIO_GetMaskedPortValue(LPC_GPIO_PORT, 0) >> 2;
	hz = 1000 * (sw + 1);

	Chip_SCTPWM_SetRate(LPC_SCT, hz);
	Chip_SCTPWM_SetDutyCycle(LPC_SCT, 1, Chip_SCTPWM_PercentageToTicks(LPC_SCT, 50));
	Chip_SCTPWM_Start(LPC_SCT);

}

void PININT7_IRQHandler(void){
	Chip_PININT_ClearIntStatus(LPC_PININT, PININTCH7);

	mrtOneshot(MRT_MS(100), changeFreq);
}

int main(void) {

#if defined (__USE_LPCOPEN)
#if !defined(NO_BOARD_LIB)
    // Read clock settings and update SystemCoreClock variable
    SystemCoreClockUpdate();
    // Set up and initialize all required blocks and
    // functions related to the board hardware
    Board_Init();
    // Set the LED to the state of "On"
    Board_LED_Set(0, true);
#endif
#endif

    // TODO: insert code here
	SystemCoreClockUpdate();

	//setup pins
   	Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_SWM);
   	Chip_SWM_DisableFixedPin(SWM_FIXED_SWCLK);
   	Chip_SWM_DisableFixedPin(SWM_FIXED_SWDIO);
   	Chip_SWM_DisableFixedPin(SWM_FIXED_RST);
   	Chip_SWM_MovablePinAssign(SWM_CTOUT_0_O, 0);
   	Chip_Clock_DisablePeriphClock(SYSCTL_CLOCK_SWM);

	Chip_SCTPWM_Init(LPC_SCT);
	Chip_SCTPWM_SetRate(LPC_SCT, 1000);
	Chip_SCTPWM_SetDutyCycle(LPC_SCT, 1, Chip_SCTPWM_PercentageToTicks(LPC_SCT, 50));
	Chip_SCTPWM_SetOutPin(LPC_SCT, 1, 0);
	Chip_SCTPWM_Start(LPC_SCT);

	Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_IOCON);
	Chip_IOCON_PinEnableInputInverted(LPC_IOCON, IOCON_PIO2);
	Chip_IOCON_PinEnableInputInverted(LPC_IOCON, IOCON_PIO3);
	Chip_IOCON_PinEnableInputInverted(LPC_IOCON, IOCON_PIO4);
	Chip_IOCON_PinEnableInputInverted(LPC_IOCON, IOCON_PIO5);
	Chip_Clock_DisablePeriphClock(SYSCTL_CLOCK_IOCON);

	Chip_GPIO_SetPortMask(LPC_GPIO_PORT, 0, ~(0x3f));
	mrtSetup();

	Chip_SYSCTL_SetPinInterrupt(7, 2);
	Chip_PININT_SetPinModeEdge(LPC_PININT, PININTCH7);
	Chip_PININT_EnableIntHigh(LPC_PININT, PININTCH7);
	Chip_PININT_EnableIntLow(LPC_PININT, PININTCH7);
	NVIC_EnableIRQ(PININT7_IRQn);

	while(1) __WFI();
    return 0 ;
}
