/*
===============================================================================
 Name        : pwm810.c
 Author      : $(author)
 Version     :
 Copyright   : $(copyright)
 Description : main definition
===============================================================================
*/

#if defined (__USE_LPCOPEN)
#if defined(NO_BOARD_LIB)
#include "chip.h"
#else
#include "board.h"
#endif
#endif

#include <cr_section_macros.h>

// TODO: insert other include files here
// TODO: insert other definitions and declarations here
#include "pwm.h"
#include "i2cs.h"

#define I2C_ADDR (0x26 << 1)
#define LED_HZ 255//Safety minimum 255

void i2csAlarmCallback(){
	pwmDutySetup(0, 99);
	pwmDutySetup(1, 0);
	pwmDutySetup(2, 0);
}

void i2csRxCallback(){
	int i;
	uint8_t data;

	for(i = 0; i < 3; i++){
		data = i2csRxBuf[i + 1];
		i2csTxBuf[i] = data;
		pwmDutySetup(i,	data);
	}
}

int main(void) {

#if defined (__USE_LPCOPEN)
#if !defined(NO_BOARD_LIB)
    // Read clock settings and update SystemCoreClock variable
    SystemCoreClockUpdate();
    // Set up and initialize all required blocks and
    // functions related to the board hardware
    Board_Init();
    // Set the LED to the state of "On"
    Board_LED_Set(0, true);
#endif
#endif

    // TODO: insert code here
	SystemCoreClockUpdate();

   	Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_SWM);
   	Chip_SWM_DisableFixedPin(SWM_FIXED_SWCLK);// Disable SWCLK
   	Chip_SWM_DisableFixedPin(SWM_FIXED_SWDIO);// Disable SWDIO
   	Chip_SWM_MovablePinAssign(SWM_CTOUT_0_O, 2);
   	Chip_SWM_MovablePinAssign(SWM_CTOUT_1_O, 3);
   	Chip_SWM_MovablePinAssign(SWM_CTOUT_2_O, 4);
	Chip_SWM_MovablePinAssign(SWM_I2C_SDA_IO, 0);//I2C_SDA
	Chip_SWM_MovablePinAssign(SWM_I2C_SCL_IO, 1);//I2C_SCL
   	Chip_Clock_DisablePeriphClock(SYSCTL_CLOCK_SWM);

	pwmCounterSetup(LED_HZ);
	pwmChannelSetup(0, 50);
	pwmChannelSetup(1, 50);
	pwmChannelSetup(2, 50);
	pwmStart();

	i2csSetupErr(i2csAlarmCallback);
	i2csSetupRx(i2csRxCallback);
	i2csSetup(I2C_ADDR, 4, 3);

	while(1) __WFI();
    return 0 ;
}
