/*
 ===============================================================================
 Name        : main.c
 Author      : $(author)
 Version     :
 Copyright   : $(copyright)
 Description : main definition
 ===============================================================================
 */

#if defined (__USE_LPCOPEN)
#if defined(NO_BOARD_LIB)
#include "chip.h"
#else
#include "board.h"
#endif
#endif

#include <cr_section_macros.h>

// TODO: insert other include files here
#include "mrt.h"
#include "ws2812.h"

// TODO: insert other definitions and declarations here
static const uint8_t sig[] = {
		0xff, 0x00, 0x00, // red
		0x00, 0xff, 0x00, // green
		0x00, 0x00, 0xff, // blue
		0xff, 0xff, 0xff, // white
		0xff, 0x00, 0x00, // red
		0x00, 0xff, 0x00, // green
		0x00, 0x00, 0xff, // blue
		};

int main(void) {

#if defined (__USE_LPCOPEN)
#if !defined(NO_BOARD_LIB)
	// Read clock settings and update SystemCoreClock variable
	SystemCoreClockUpdate();
	// Set up and initialize all required blocks and
	// functions related to the board hardware
	Board_Init();
	// Set the LED to the state of "On"
	Board_RGB_Set(0, true);
#endif
#endif

	// TODO: insert code here
	SystemCoreClockUpdate();

	Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_SWM);
	Chip_SWM_DisableFixedPin(SWM_FIXED_SWCLK);    // Disable SWCLK
	Chip_SWM_DisableFixedPin(SWM_FIXED_SWDIO);    // Disable SWDIO
	Chip_Clock_DisablePeriphClock(SYSCTL_CLOCK_SWM);

	Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_IOCON);
	Chip_IOCON_PinSetMode(LPC_IOCON, IOCON_PIO2, PIN_MODE_INACTIVE);
	Chip_Clock_DisablePeriphClock(SYSCTL_CLOCK_IOCON);

	Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_GPIO);
	Chip_GPIO_SetPinDIROutput(LPC_GPIO_PORT, 0, 2);
	Chip_GPIO_SetPinOutLow(LPC_GPIO_PORT, 0, 2);

	mrtSetup();

	uint8_t count = 0;
	while (1) {

		__disable_irq();
		rgbWrite(&sig[(count++ & 0x03) * 3], 12);
		__enable_irq();

		mrtWait(MRT_MS(500));
	}
	return 0;
}
